type expr =
  | Var of string
  | Lam of string * expr
  | App of expr * expr

let rec output_expr () = function
  | Var x -> Printf.sprintf "%s" x
  | Lam(x, e) -> Printf.sprintf "%s.%a" x output_expr e
  | App(e1, e2) -> Printf.sprintf "(%a) (%a)" output_expr e1 output_expr e2

let unparse = output_expr ()

let free_vars e = failwith "Unimplemented"

let is_alpha e1 e2 = failwith "Unimplemented"

let subst x e1 e2 = failwith "Unimplemented"

let beta e = failwith "Unimplemented"

let normal_form e = failwith "Unimplemented"

let expr_of_int n = failwith "Unimplemented"

let add e1 e2 = failwith "Unimplemented"

let int_of_expr e = failwith "Unimplemented"
